/* common_structures.h
 *
 * Common response structure definitions
 *
 * This file can be used by Lua FFI.
 *
 */

#pragma pack(push)
#pragma pack(1)


typedef enum { CMD_OK = 1,
               CMD_OK_TS,
               CMD_ERROR,
               CMD_STARTED,
               CMD_UPDATE,
               CMD_STOPPED,
               CMD_CHANNEL_SPECIFIC,
               CC_ASYNC_ERROR,
               CC_ASYNC_FATAL_ERR,
               CC_LAST_STATUS = 0x7FFFFFFF
} status_t;

typedef struct {
    status_t        status;
    uint32_t        cmd;
    uint32_t        cmd_id;
    union {
        int64_t     ts;
        uint32_t    phys_address;
        uint32_t    channel_specific[61];
        char        error_message[244];
    } prm;
} irq_s;

typedef struct {
    uint64_t        base_period;
    uint64_t        rate_numerator;
    uint64_t        remainder;
} cmd_rate_parameters_s;

typedef struct {
    int64_t         ts_adjust;
} cmd_ts_offset_s;

typedef struct {
    int64_t                     start_time;
    cmd_rate_parameters_s       heartbeat_interval;
    uint32_t                    phys_address;
} cmd_event_start_s;

#pragma pack(pop)

