require 'middleclass'
require 'middleclass-extras.Indexable'

local armada_class = class('armada')
armada_class:include(Indexable)

local function dbus_loader(name)
    return function (armada)
        require 'ev'
        if ev.Loop.default:depth() > 0 then
            return armada.system_bus:auto_proxy('com.somat.armada.'..name,
                                                '/com/somat/armada/'..name)
        else
            return armada.system_bus:auto_proxy_wait('com.somat.armada.'..name,
                                                     '/com/somat/armada/'..name)
        end
    end
end

local autoload = {
    system_bus = function ()
        local dbus = require 'dbus'
        local system_bus = dbus.bus_get('system')
        system_bus:hook_libev_default_loop()
        return system_bus
    end,

    logger = dbus_loader('Logger'),
    master = dbus_loader('Master'),
    network = dbus_loader('Network'),
    timing = dbus_loader('Timing'),
}

function armada_class:index(name)
    if autoload[name] then
        self[name] = autoload[name](self)
        return self[name]
    end
    error('unknown armada object element ' .. name)
end

return armada_class:new()
