local ffi = require 'ffi'
local lj_include = require 'lj_include'

lj_include('sys_types')
lj_include('bits_uio')

ffi.cdef[[
ssize_t readv(int __fd, const struct iovec *__iovec, int __count);
ssize_t writev(int __fd, const struct iovec *__iovec, int __count);
ssize_t preadv(int __fd, const struct iovec *__iovec, int __count,
    __off_t __offset);
ssize_t pwritev(int __fd, const struct iovec *__iovec, int __count,
    __off_t __offset);
ssize_t preadv64(int __fd, const struct iovec *__iovec, int __count,
    __off64_t __offset);
ssize_t pwritev64(int __fd, const struct iovec *__iovec, int __count,
    __off64_t __offset);
]]

local defs = {
}
local format, cdef, C = string.format, ffi.cdef, ffi.C
for sym, val in pairs(defs) do
    if not pcall(function() return C[sym] end) then
        cdef(format("enum {%s = %s};", sym, val))
    end
end

