--
-- Copyright (C) 2015 Hottinger Baldwin Measurements, Inc.
--

local m = { }

--[[
The MX471B does not have a fixed set of available channels, like most other MX
devices. Instead, it has four "virtual" channels: one for each CAN connector.
Tell the mx_proxy to create MX471B-specific channel proxy objects for each of
these "virtual channels."
--]]

m.virtual_channels = { }
for i = 1, 4 do
    m.virtual_channels[#m.virtual_channels + 1] = {
        name         = 'can' .. i,
        channel_num  = i
    }
end

m.use_libhbmstream = true

return m
